#******************************************
# script to visualize 2dm mesh with paraview engine
# to run: pvpython visualizer.py MESHNAME version scale'
# where:
# 'MESHNAME' is the full path to the 2dm file,
# 'version' is 'v28' (BM<=2.8) or 'v30' (BM>=3.0) [default 'v30'],
# 'scale' is a float number to scale the vertical axes [default '1.0'].
#
# by Davide Vanzo 2018
import sys
import numpy as np
#import pyvtk
import vtk
from vtk.util import numpy_support as ns
#from paraview.simple import *

#---------------------------------------------------------------
def read2dm (filename2dm, version='v30'):
        # import .2dm file, generated by SMS or QGIS
        try:
            File = open(filename2dm,'r')
        except:
            print ("could not open the file '%s'!" % filename2dm)
            return
        lineCounter = 0
        topo = []
        matID = []
        bedElev = []
        coords = []
        for line in File:
            # parse line
            tokens = line.strip().split()
            if len(tokens) < 1:
                continue
            if tokens[0] in ["MESH2d", "MESH2D", "MESHNAME"]:
                continue
            # store triangle data in list
            if tokens[0] == "E3T":
                if version == 'v30':
                    minLength = 7
                else:
                    minLength = 6
                if len(tokens) < minLength:
                    print ("Error found in 2dm file at cell-definition at line #" + str(lineCounter+1) +". Cannot proceed.")
                    return
                else:
                    topo.append([int(tokens[2])-1, int(tokens[3])-1, int(tokens[4])-1])
                    matID.append(int(tokens[5]))
                if version == 'v30':
                    bedElev.append(float(tokens[6]))
                else:
                    bedElev.append(0.0)
            # store quadrilateral data in list
            elif tokens[0] == "E4Q":
                print ("Error found in 2dm file at cell-definition at line #" + str(lineCounter+1) +". No support for quadrilateral elements.")
                return
            # add node to mesh
            elif tokens[0] == "ND":
                if len(tokens) < 5:
                    print ("Error found in 2dm file at node-definition at line #" + str(lineCounter+1) +". Cannot proceed.")
                    return
                else:
                    if version == 'v30':
                        coords.append([float(tokens[2]), float(tokens[3]), 0.0])
                    else:
                        coords.append([float(tokens[2]), float(tokens[3]), float(tokens[4])])
            # go to next line
            lineCounter = lineCounter + 1
        File.close()

        # return the results
        print '-> reading input 2dm... done'
        return topo, coords, matID, bedElev
#--------------------------------------------------------------------------------------------

def generate_VTK_UnstructuredGrid(topo,coords, matID, Z):
    n_cells = len(matID)

    #create the points
    points = vtk.vtkPoints()
    for i in range(0, len(coords)):
        points.InsertPoint(i, coords[i])

    #allocate the grid
    ugrid = vtk.vtkUnstructuredGrid()
    ugrid.Allocate(n_cells)

    #add the cells
    for j in range(n_cells):
        ugrid.InsertNextCell(vtk.VTK_TRIANGLE, 3, topo[j])
    #add the points
    ugrid.SetPoints(points)

    #add the cell data
    vtk_Z = vtk.vtkFloatArray()
    vtk_Z.SetName('bed')
    for w in range(n_cells):
        vtk_Z.InsertValue(w, Z[w])
    ugrid.GetCellData().AddArray(vtk_Z)

    vtk_matID = vtk.vtkIntArray()
    vtk_matID.SetName('matID')
    for w in range(n_cells):
        vtk_matID.InsertValue(w, matID[w])
    ugrid.GetCellData().AddArray(vtk_matID)
    #ugrid.GetCellData().SetActiveScalars('bed')

    print '-> generating vtk unstructured grid... done'
    return ugrid

def elevateMesh(grid): #NOT WORKING YET
    shrink = vtk.vtkShrinkFilter()
    shrink.SetInput(grid)
    shrink.SetShrinkFactor(0.99)

    Cell2Point = vtk.vtkCellDataToPointData()
    Cell2Point.SetInputData(grid)
    Cell2Point.PassCellDataOn()


    # create a new 'Warp By Scalar'
    warp = vtk.vtkWarpScalar()
    warp.SetInputConnection(Cell2Point.GetOutputPort())
    warp.SetScaleFactor(1.0)

    warp.SetScalars('POINTS', 'bed')


def mapGrid(grid, warp,mapper, actor,lookuptable,legend_actor,var,label):
    grid.GetCellData().SetActiveScalars(var)

    # get value range
    valueRange = grid.GetCellData().GetArray(var).GetRange()

    # set the mapper
    mapper.SetInputConnection(warp.GetOutputPort())
    mapper.SetScalarRange(valueRange)
    mapper.SetLookupTable(lookuptable)

    # set the lookuptable
    lookuptable.SetTableRange(valueRange)

    # set the legend
    legend_actor.SetLookupTable(lookuptable)
    legend_actor.SetTitle(label)

    # set the actor
    actor.SetMapper( mapper )


class MyInteractorStyle(vtk.vtkInteractorStyleTrackballCamera):

    def __init__(self,grid, warp, mapper, actor,lookuptable,legend_actor,parent=None):
        self.parent = interactor

        self.AddObserver("KeyPressEvent",self.keyPressEvent)

    def keyPressEvent(self,obj,event):
        key = self.parent.GetKeySym()
        if key == 'z':
            mapGrid(grid, warp, mapper, actor,lookuptable,legend_actor,'bed','bed elevation [m]')
        if key == 'm':
            mapGrid(grid, warp, mapper, actor,lookuptable,legend_actor,'matID','matID [-]')
        if key == 'g':
            vis = bool(actor.GetProperty().GetEdgeVisibility())
            actor.GetProperty().SetEdgeVisibility(not vis)
        return

if __name__ == "__main__":
    # MAIN SCRIPT ---------------

    if len(sys.argv)<3:
        print ("---")
        print ("WARNING: full script call should be... 'python vtkVis.py MESHNAME scale'")
        print ("where 'scale' is a float number to scale the vertical axes (1 if missing)")
        print ("---")

    #get 2dm filename
    filename = str(sys.argv[1])
    try:
        Zscale = float(sys.argv[2])
    except:
        Zscale = 1.0

    #read the data from the 2dm
    version = 'v30'
    topo,coords, matID, Z = read2dm(filename, version)

    # generate the unstructuredgrid
    grid = generate_VTK_UnstructuredGrid(topo,coords, matID, Z)
    shrink = vtk.vtkShrinkFilter()
    shrink.SetInputData(grid)
    shrink.SetShrinkFactor(0.99)

    Cell2Point = vtk.vtkCellDataToPointData()
    Cell2Point.SetInputConnection(shrink.GetOutputPort())
    Cell2Point.PassCellDataOn()


    # create a new 'Warp By Scalar'
    warp = vtk.vtkWarpScalar()
    warp.SetInputConnection(Cell2Point.GetOutputPort())
    warp.SetScaleFactor(Zscale)

    # create different VTK objects
    mapper = vtk.vtkDataSetMapper()
    lookuptable = vtk.vtkLookupTable() #generate_lookup_table()
    actor = vtk.vtkActor()
    actorWarp = vtk.vtkActor()
    legend_actor = vtk.vtkScalarBarActor()
    colors = vtk.vtkNamedColors()

    # format the legend actor
    legend_actor.GetLabelTextProperty().SetFontFamilyToArial()
    legend_actor.GetLabelTextProperty().SetFontSize(12)
    legend_actor.GetLabelTextProperty().SetColor(colors.GetColor3d("Black"))
    legend_actor.GetTitleTextProperty().SetFontFamilyToArial()
    legend_actor.GetTitleTextProperty().SetFontSize(24)
    legend_actor.GetTitleTextProperty().SetColor(colors.GetColor3d("Black"))

    # format the default actor
    mapGrid(grid, warp, mapper, actor,lookuptable,legend_actor,'bed','bed elevation [m]')

    # create and format the camera
    camera = vtk.vtkCamera()


    #axesref = vtk.vtkAxesActor()

    # outline
    #outline = vtk.vtkOutlineFilter()
    #outline.SetInputConnection(warp.GetOutputPort())
    #mapper2 = vtk.vtkPolyDataMapper()
    #mapper2.SetInputConnection(outline.GetOutputPort())
    #actor2 = vtk.vtkActor()
    #actor2.SetMapper(mapper2)


    # create and setup the renderer
    renderer = vtk.vtkRenderer()
    renderer.AddActor(actor)
    #renderer.AddActor(actor2)
    #renderer.AddActor(axesref)
    renderer.AddActor(legend_actor)
    renderer.SetBackground(colors.GetColor3d("Beige"))
    renderer.SetActiveCamera(camera)
    renderer.ResetCamera()


    # visualize some instructions
    instructions = '(g) toggle edge visibitily on/off\n' +\
                   '(m) visualize matID [-]\n' +\
                   '(z) visualize bed elevation [m]\n' +\
                   '(s) surface representation\n' +\
                   '(w) wireframe representation\n' +\
                   '(f) fly-to the point (and set rotation center)\n' +\
                   '(r) reset the camera\n' +\
                   '(q) quit the viewer\n'
    textActor = vtk.vtkTextActor()
    textActor.SetInput(instructions)
    textActor.GetTextProperty().SetFontFamilyToArial()
    textActor.GetTextProperty().SetFontSize(24)
    textActor.GetTextProperty().SetColor(colors.GetColor3d("Black"))
    textActor.SetDisplayPosition(10,10)
    renderer.AddActor2D(textActor)

    # create and setup a renderer window
    renderer_window = vtk.vtkRenderWindow()
    renderer_window.AddRenderer(renderer)
    renderer_window.SetSize(1024, 768)

    # create and setup a window interactor
    interactor = vtk.vtkRenderWindowInteractor()
    interactor.SetInteractorStyle(MyInteractorStyle(grid, warp, mapper, actor,lookuptable,legend_actor))
    interactor.SetRenderWindow(renderer_window)
    renderer_window.Render()

    interactor.Initialize()
    interactor.Start()